// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{ffi, ImageKind};
use glib::{prelude::*, translate::*};

glib::wrapper! {
    #[doc(alias = "AsImage")]
    pub struct Image(Object<ffi::AsImage, ffi::AsImageClass>);

    match fn {
        type_ => || ffi::as_image_get_type(),
    }
}

impl Image {
    pub const NONE: Option<&'static Image> = None;

    #[doc(alias = "as_image_new")]
    pub fn new() -> Image {
        assert_initialized_main_thread!();
        unsafe { from_glib_full(ffi::as_image_new()) }
    }
}

impl Default for Image {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Image>> Sealed for T {}
}

pub trait ImageExt: IsA<Image> + sealed::Sealed + 'static {
    #[doc(alias = "as_image_get_height")]
    #[doc(alias = "get_height")]
    fn height(&self) -> u32 {
        unsafe { ffi::as_image_get_height(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_image_get_kind")]
    #[doc(alias = "get_kind")]
    fn kind(&self) -> ImageKind {
        unsafe { from_glib(ffi::as_image_get_kind(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_image_get_locale")]
    #[doc(alias = "get_locale")]
    fn locale(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_image_get_locale(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_image_get_scale")]
    #[doc(alias = "get_scale")]
    fn scale(&self) -> u32 {
        unsafe { ffi::as_image_get_scale(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_image_get_url")]
    #[doc(alias = "get_url")]
    fn url(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::as_image_get_url(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "as_image_get_width")]
    #[doc(alias = "get_width")]
    fn width(&self) -> u32 {
        unsafe { ffi::as_image_get_width(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "as_image_set_height")]
    fn set_height(&self, height: u32) {
        unsafe {
            ffi::as_image_set_height(self.as_ref().to_glib_none().0, height);
        }
    }

    #[doc(alias = "as_image_set_kind")]
    fn set_kind(&self, kind: ImageKind) {
        unsafe {
            ffi::as_image_set_kind(self.as_ref().to_glib_none().0, kind.into_glib());
        }
    }

    #[doc(alias = "as_image_set_locale")]
    fn set_locale(&self, locale: &str) {
        unsafe {
            ffi::as_image_set_locale(self.as_ref().to_glib_none().0, locale.to_glib_none().0);
        }
    }

    #[doc(alias = "as_image_set_scale")]
    fn set_scale(&self, scale: u32) {
        unsafe {
            ffi::as_image_set_scale(self.as_ref().to_glib_none().0, scale);
        }
    }

    #[doc(alias = "as_image_set_url")]
    fn set_url(&self, url: &str) {
        unsafe {
            ffi::as_image_set_url(self.as_ref().to_glib_none().0, url.to_glib_none().0);
        }
    }

    #[doc(alias = "as_image_set_width")]
    fn set_width(&self, width: u32) {
        unsafe {
            ffi::as_image_set_width(self.as_ref().to_glib_none().0, width);
        }
    }
}

impl<O: IsA<Image>> ImageExt for O {}
